#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define FALSE 0
#define TRUE !FALSE

#define EINGABELAENGE 40

struct stock_data
{
   char name[EINGABELAENGE];
   float buy_price;
   float current_price;
};

void write_info(void);
void read_info(void);

int main()
{
   char c;
   int done = FALSE;

   while(!done)
   {
      puts("\nAktienportfolio\n");
      puts("N - Neue Aktie\n");
      puts("A - Anzeige Bestand\n");
      puts("E - Ende\n");
      printf("Ihre Wahl: ");

      fflush(stdin);
      c = (char)toupper(getchar());

      switch(c)
      {
      case('N'):
         puts("Neue Aktie\n");
         write_info();
         break;
      case('A'):
         puts("Anzeige Portfolio\n");
         read_info();
         break;
      case('E'):
         puts("Ende\n");
         done = TRUE;
         break;
      default:
         puts("?");
         break;
      }
   }

   return 0;
}

void write_info(void)
{
   FILE* stocks;
   struct stock_data stock;
   char input[EINGABELAENGE + 1];

   fflush(stdin);
   printf("Aktienname: ");
   fgets(stock.name, EINGABELAENGE, stdin);
   printf("Kaufkurs: ");
   stock.buy_price = (float)atof(fgets(input, EINGABELAENGE, stdin));
   stock.current_price = stock.buy_price / 11;

   stocks = fopen("stocks.dat", "a");
   if (stocks == NULL)
   {
      puts("Dateifehler");
      exit(1);
   }

   fwrite(&stock, sizeof(stock), 1, stocks);

   fclose(stocks);
   puts("Aktie hinzugefuegt");
}

void read_info(void)
{
   FILE* stocks;
   struct stock_data stock;
   int x;

   stocks = fopen("stocks.dat", "r");
   if (stocks == NULL)
   {
      puts("Datei ist leer oder nicht vorhanden");
      return;
   }

   while (TRUE)
   {
      x = fread(&stock, sizeof(stock), 1, stocks);

      if (x == 0)
         break;

      printf("\nName: %s\n", stock.name);
      printf("Kaufkurs: EUR %.2f\n", stock.buy_price);
      printf("Aktueller Kurs: EUR %.2f\n", stock.current_price);
   }

   fclose(stocks);
}
